(*Ŀ
  Source                                                                  
                                                                  
                                                                            
                          coded by bca                                      
Ĵ
  Info                                                                    
                                                                    
                                                                            
               Another old pascal tunnel effect                             
Ĵ
  Fichiers ncessaires                                                    
                                                    
                                                                            
 -> '256x256.Pcx' : Texture du tunnel                                       
*)

{$E+,G+,N-,Q-,S-,R-}

{$M 2048,0,162000}

uses Clavier,EcranVga,Pcx;

const
  radius = 8000;

type
  Coordonnee     = record x,y : byte end;
  TypeTablePos   = array[0..0] of Coordonnee;
  Texture256x256 = array[0..0,0..255] of byte;

var
  TamponEcran: PtrImage;
  TablePos : ^TypeTablePos;
  texture  : ^Texture256x256;
  index,vram: word;
  iy,ix,p    : integer;
  angle,dist : byte;

procedure PreCalcul; var a : real; begin
  index := 0;
  for iy := 100 downto 1 do
  for ix := 160 downto 1 do begin
    a := ArcTan (iy/ix);
    TablePos^[index].x := round(a/PI*256);
    TablePos^[index].y := round(cos(a)*radius/ix);
    inc(index)
  end;
end;

procedure DessineTunnel; begin
  { Haut }
  index := 0; vram := 0;
  for iy := 0 to 99 do begin
    for ix := 0 to 159 do begin
      { Gauche }
      TamponEcran^[vram +ix] := Texture^[ TablePos^[index ].x +angle,-TablePos^[index ].y-dist];
      { Droit }
      TamponEcran^[vram +319-ix] := Texture^[ 255-TablePos^[index ].x+angle,-TablePos^[index ].y-dist];
      inc (index);
    end;
    inc(vram,320);
  end;

  { Bas }
  index := 0; vram := 199*320;
  for iy := 0 to 99 do begin
    for ix := 0 to 159 do begin
      { Gauche }
      TamponEcran^[vram +ix] := Texture^[-256-TablePos^[index ].x+angle,255-TablePos^[index ].y-dist];
      { Droit }
      TamponEcran^[vram +319-ix] := Texture^[256+TablePos^[index ].x+angle,255-TablePos^[index ].y-dist];
      inc (index);
    end;
    dec(vram,320);
  end;

  AttendEcran;
  AfficheEcran;
end;

begin
  { Alloue de la mmoire }
  if MemAvail< (256*256)+(160*100*2)+(64000) then begin
    ModeTxt;
    Writeln ('Pas assez de mmoire libre pour allouer les tampons !');
    Writeln ('(manque ',(65535+160*100*2+64000)-MemAvail,' octets )');
    halt;
  end;
  Writeln ('Pr-calcul ...'); GetMem(TablePos,160*100*2); PreCalcul;
  GetMem (TamponEcran,64000);
  ChangeDestEcran (TamponEcran);
  EffaceEcran (0);
  GetMem(texture,$FFFF);

  { Mode graphique 320x200x256, charge la texture }
  ModeVga256; ChargePcx (Texture,'256x256');

  repeat
    DessineTunnel;
    inc (angle,2);
    inc (dist,2);
  until TouchPresse;

  { Libre la mmoire }
  ModeTxt;
  Dispose (Texture);
  Dispose (TamponEcran);
  Dispose (TablePos);
end.
